 require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/labels/qqoqcp_lines', type: :request do
  # Labels::QqoqcpLine. As you add validations to Labels::QqoqcpLine, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { { internal_name: 'who', name: 'WHO?' } }
  let(:invalid_attributes) { { internal_name: 'who is here ?', name: 'WHO?' } }

  let(:user) { FactoryBot.create(:user) }

  before :each do
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Labels::QqoqcpLine.create! valid_attributes
      get labels_qqoqcp_lines_url
      expect(response).to be_successful
    end
  end

  # describe 'GET /show' do
  #   it 'renders a successful response' do
  #     labels_qqoqcp_line = Labels::QqoqcpLine.create! valid_attributes
  #     get labels_qqoqcp_line_url(labels_qqoqcp_line)
  #     expect(response).to be_successful
  #   end
  # end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_labels_qqoqcp_line_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      labels_qqoqcp_line = Labels::QqoqcpLine.create! valid_attributes
      get edit_labels_qqoqcp_line_url(labels_qqoqcp_line)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Labels::QqoqcpLine' do
        expect {
          post labels_qqoqcp_lines_url, params: { labels_qqoqcp_line: valid_attributes }
        }.to change(Labels::QqoqcpLine, :count).by(1)
      end

      it 'redirects to labels_qqoqcp_lines index' do
        post labels_qqoqcp_lines_url, params: { labels_qqoqcp_line: valid_attributes }
        expect(response).to redirect_to(labels_qqoqcp_lines_url)
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Labels::QqoqcpLine' do
        expect {
          post labels_qqoqcp_lines_url, params: { labels_qqoqcp_line: invalid_attributes }
        }.to change(Labels::QqoqcpLine, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post labels_qqoqcp_lines_url, params: { labels_qqoqcp_line: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { { name: 'WHO NEW' } }

      it 'updates the requested labels_qqoqcp_line' do
        labels_qqoqcp_line = Labels::QqoqcpLine.create! valid_attributes
        patch labels_qqoqcp_line_url(labels_qqoqcp_line), params: { labels_qqoqcp_line: new_attributes }
        labels_qqoqcp_line.reload
        expect(labels_qqoqcp_line.name).to eq 'WHO NEW'
      end

      it 'redirects to labels_qqoqcp_lines index' do
        labels_qqoqcp_line = Labels::QqoqcpLine.create! valid_attributes
        patch labels_qqoqcp_line_url(labels_qqoqcp_line), params: { labels_qqoqcp_line: new_attributes }
        labels_qqoqcp_line.reload
        expect(response).to redirect_to(labels_qqoqcp_lines_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        labels_qqoqcp_line = Labels::QqoqcpLine.create! valid_attributes
        patch labels_qqoqcp_line_url(labels_qqoqcp_line), params: { labels_qqoqcp_line: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested labels_qqoqcp_line' do
      labels_qqoqcp_line = Labels::QqoqcpLine.create! valid_attributes
      expect {
        delete labels_qqoqcp_line_url(labels_qqoqcp_line)
      }.to change(Labels::QqoqcpLine, :count).by(-1)
    end

    it 'redirects to the labels_qqoqcp_lines list' do
      labels_qqoqcp_line = Labels::QqoqcpLine.create! valid_attributes
      delete labels_qqoqcp_line_url(labels_qqoqcp_line)
      expect(response).to redirect_to(labels_qqoqcp_lines_url)
    end
  end
end
